Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/MultiObjective/HypervolumeCalculator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/MultiObjective/HypervolumeCalculator.cs	(revision 17225)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/MultiObjective/HypervolumeCalculator.cs	(revision 17225)
@@ -0,0 +1,312 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Optimization {
+  public static class HypervolumeCalculator {
+    public static double[] CalculateNadirPoint(IEnumerable<double[]> qualities, bool[] maximization) {
+      var res = maximization.Select(m => m ? double.MaxValue : double.MinValue).ToArray();
+      foreach (var quality in qualities)
+        for (var i = 0; i < quality.Length; i++)
+          if (maximization[i] == res[i] > quality[i])
+            res[i] = quality[i];
+      return res;
+    }
+
+    /// <summary>
+    /// The Hypervolume-metric is defined as the HypervolumeCalculator enclosed between a given reference point,
+    /// that is fixed for every evaluation function and the evaluated qualities.
+    /// 
+    /// Example:
+    /// r is the reference point at (1|1) and every point p is part of the evaluated qualities
+    /// The filled area labled HV is the 2 dimensional HypervolumeCalculator enclosed by this qualities. 
+    /// 
+    /// (0|1)                (1|1)
+    ///   +      +-------------r
+    ///   |      |###### HV ###|
+    ///   |      p------+######|
+    ///   |             p+#####|
+    ///   |              |#####|
+    ///   |              p-+###|
+    ///   |                p---+
+    ///   |                 
+    ///   +--------------------1
+    /// (0|0)                (1|0)
+    /// 
+    ///  Please note that in this example both dimensions are minimized. The reference point needs to be dominated by EVERY point in the evaluated qualities 
+    /// 
+    /// </summary>
+    /// 
+    public static double CalculateHypervolume(IList<double[]> qualities, double[] referencePoint, bool[] maximization) {
+      qualities = qualities.Where(vec => DominationCalculator.Dominates(vec, referencePoint, maximization, false) == DominationResult.Dominates).ToArray();
+      if (qualities.Count== 0) return 0; //TODO computation for negative hypervolume?
+      if (maximization.Length == 2)
+        return Calculate2D(qualities, referencePoint, maximization);
+
+      if (Array.TrueForAll(maximization, x => !x))
+        return CalculateMultiDimensional(qualities, referencePoint);
+      throw new NotImplementedException("HypervolumeCalculator calculation for more than two dimensions is supported only with minimization problems.");
+    }
+
+
+    /// <summary>
+    /// Caluclates the Hypervolume for a 2 dimensional problem
+    /// </summary>
+    /// <param name="front">All points within the front need to be Non-Dominated and need to dominate the reference point</param>
+    /// <param name="referencePoint"></param>
+    /// <param name="maximization"></param>
+    /// <returns></returns>
+    public static double Calculate2D(IList<double[]> front, double[] referencePoint, bool[] maximization) {
+      if (front == null) throw new ArgumentNullException("front");
+      if (referencePoint == null) throw new ArgumentNullException("referencePoint");
+      if (maximization == null) throw new ArgumentNullException("maximization");
+      if (!front.Any()) throw new ArgumentException("Front must not be empty.");
+      if (referencePoint.Length != 2) throw new ArgumentException("ReferencePoint must have exactly two dimensions.");
+
+      var set = front.ToArray();
+      if (set.Any(s => s.Length != 2)) throw new ArgumentException("Points in qualities must have exactly two dimensions.");
+
+      Array.Sort(set, new DimensionComparer(0, maximization[0]));
+
+      double sum = 0;
+      for (var i = 0; i < set.Length - 1; i++)
+        sum += Math.Abs(set[i][0] - set[i + 1][0]) * Math.Abs(set[i][1] - referencePoint[1]);
+      var lastPoint = set[set.Length - 1];
+      sum += Math.Abs(lastPoint[0] - referencePoint[0]) * Math.Abs(lastPoint[1] - referencePoint[1]);
+
+      return sum;
+    }
+
+    public static double CalculateMultiDimensional(IList<double[]> front, double[] referencePoint) {
+      if (referencePoint == null || referencePoint.Length < 3) throw new ArgumentException("ReferencePoint unfit for complex HypervolumeCalculator calculation");
+
+      var objectives = referencePoint.Length;
+      var fronList = front.ToList();
+      fronList.StableSort(new DimensionComparer(objectives - 1, false));
+
+      var regLow = Enumerable.Repeat(1E15, objectives).ToArray();
+      foreach (var p in fronList) {
+        for (var i = 0; i < regLow.Length; i++) {
+          if (p[i] < regLow[i]) regLow[i] = p[i];
+        }
+      }
+
+      return Stream(regLow, referencePoint, fronList, 0, referencePoint[objectives - 1], (int)Math.Sqrt(fronList.Count), objectives);
+    }
+
+
+    //within Stream a number of equality comparisons on double values are performed
+    //this is intentional and required
+    private static double Stream(double[] regionLow, double[] regionUp, List<double[]> front, int split, double cover, int sqrtNoPoints, int objectives) {
+      var coverOld = cover;
+      var coverIndex = 0;
+      var coverIndexOld = -1;
+      int c;
+      double result = 0;
+
+      var dMeasure = GetMeasure(regionLow, regionUp, objectives);
+      while (cover == coverOld && coverIndex < front.Count()) {
+        if (coverIndexOld == coverIndex) break;
+        coverIndexOld = coverIndex;
+        if (Covers(front[coverIndex], regionLow, objectives)) {
+          cover = front[coverIndex][objectives - 1];
+          result += dMeasure * (coverOld - cover);
+        } else coverIndex++;
+      }
+
+      for (c = coverIndex; c > 0; c--) if (front[c - 1][objectives - 1] == cover) coverIndex--;
+      if (coverIndex == 0) return result;
+
+      var allPiles = true;
+      var piles = new int[coverIndex];
+      for (var i = 0; i < coverIndex; i++) {
+        piles[i] = IsPile(front[i], regionLow, objectives);
+        if (piles[i] == -1) {
+          allPiles = false;
+          break;
+        }
+      }
+
+      if (allPiles) {
+        var trellis = new double[regionUp.Length];
+        for (var j = 0; j < trellis.Length; j++) trellis[j] = regionUp[j];
+        double next;
+        var i = 0;
+        do {
+          var current = front[i][objectives - 1];
+          do {
+            if (front[i][piles[i]] < trellis[piles[i]]) trellis[piles[i]] = front[i][piles[i]];
+            i++;
+            if (i < coverIndex) next = front[i][objectives - 1];
+            else {
+              next = cover;
+              break;
+            }
+          }
+          while (next == current);
+          result += ComputeTrellis(regionLow, regionUp, trellis, objectives) * (next - current);
+        }
+        while (next != cover);
+      } else {
+        double bound = -1;
+        var boundaries = new double[coverIndex];
+        var noBoundaries = new double[coverIndex];
+        var boundIdx = 0;
+        var noBoundIdx = 0;
+
+        do {
+          for (var i = 0; i < coverIndex; i++) {
+            var contained = ContainesBoundary(front[i], regionLow, split);
+            if (contained == 0) boundaries[boundIdx++] = front[i][split];
+            else if (contained == 1) noBoundaries[noBoundIdx++] = front[i][split];
+          }
+          if (boundIdx > 0) bound = GetMedian(boundaries, boundIdx);
+          else if (noBoundIdx > sqrtNoPoints) bound = GetMedian(noBoundaries, noBoundIdx);
+          else split++;
+        }
+        while (bound == -1.0);
+
+        var pointsChildLow = new List<double[]>();
+        var pointsChildUp = new List<double[]>();
+        var regionUpC = new double[regionUp.Length];
+        for (var j = 0; j < regionUpC.Length; j++) regionUpC[j] = regionUp[j];
+        var regionLowC = new double[regionLow.Length];
+        for (var j = 0; j < regionLowC.Length; j++) regionLowC[j] = regionLow[j];
+
+        for (var i = 0; i < coverIndex; i++) {
+          if (PartCovers(front[i], regionUpC, objectives)) pointsChildUp.Add(front[i]);
+          if (PartCovers(front[i], regionUp, objectives)) pointsChildLow.Add(front[i]);
+        }
+
+        if (pointsChildUp.Count > 0) result += Stream(regionLow, regionUpC, pointsChildUp, split, cover, sqrtNoPoints, objectives);
+        if (pointsChildLow.Count > 0) result += Stream(regionLowC, regionUp, pointsChildLow, split, cover, sqrtNoPoints, objectives);
+      }
+      return result;
+    }
+
+    private static double GetMedian(double[] vector, int length) {
+      return vector.Take(length).Median();
+    }
+
+    private static double ComputeTrellis(double[] regionLow, double[] regionUp, double[] trellis, int objectives) {
+      var bs = new bool[objectives - 1];
+      for (var i = 0; i < bs.Length; i++) bs[i] = true;
+
+      double result = 0;
+      var noSummands = BinarayToInt(bs);
+      for (uint i = 1; i <= noSummands; i++) {
+        double summand = 1;
+        IntToBinary(i, bs);
+        var oneCounter = 0;
+        for (var j = 0; j < objectives - 1; j++) {
+          if (bs[j]) {
+            summand *= regionUp[j] - trellis[j];
+            oneCounter++;
+          } else {
+            summand *= regionUp[j] - regionLow[j];
+          }
+        }
+        if (oneCounter % 2 == 0) result -= summand;
+        else result += summand;
+      }
+      return result;
+    }
+
+    private static void IntToBinary(uint i, bool[] bs) {
+      for (var j = 0; j < bs.Length; j++) bs[j] = false;
+      var rest = i;
+      var idx = 0;
+      while (rest != 0) {
+        bs[idx] = rest % 2 == 1;
+        rest = rest / 2;
+        idx++;
+      }
+    }
+
+    private static uint BinarayToInt(bool[] bs) {
+      uint result = 0;
+      for (var i = 0; i < bs.Length; i++) {
+        result += bs[i] ? ((uint)1 << i) : 0;
+      }
+      return result;
+    }
+
+    private static int IsPile(double[] cuboid, double[] regionLow, int objectives) {
+      var pile = cuboid.Length;
+      for (var i = 0; i < objectives - 1; i++) {
+        if (cuboid[i] > regionLow[i]) {
+          if (pile != objectives) return 1;
+          pile = i;
+        }
+      }
+      return pile;
+    }
+
+    private static double GetMeasure(double[] regionLow, double[] regionUp, int objectives) {
+      double volume = 1;
+      for (var i = 0; i < objectives - 1; i++) {
+        volume *= (regionUp[i] - regionLow[i]);
+      }
+      return volume;
+    }
+
+    private static int ContainesBoundary(double[] cub, double[] regionLow, int split) {
+      if (regionLow[split] >= cub[split]) return -1;
+      else {
+        for (var j = 0; j < split; j++) {
+          if (regionLow[j] < cub[j]) return 1;
+        }
+      }
+      return 0;
+    }
+
+    private static bool PartCovers(double[] v, double[] regionUp, int objectives) {
+      for (var i = 0; i < objectives - 1; i++) {
+        if (v[i] >= regionUp[i]) return false;
+      }
+      return true;
+    }
+
+    private static bool Covers(double[] v, double[] regionLow, int objectives) {
+      for (var i = 0; i < objectives - 1; i++) {
+        if (v[i] > regionLow[i]) return false;
+      }
+      return true;
+    }
+
+    private class DimensionComparer : IComparer<double[]> {
+      private readonly int dimension;
+      private readonly int descending;
+
+      public DimensionComparer(int dimension, bool descending) {
+        this.dimension = dimension;
+        this.descending = descending ? -1 : 1;
+      }
+
+      public int Compare(double[] x, double[] y) {
+        return x[dimension].CompareTo(y[dimension]) * descending;
+      }
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/CompiledProblemDefinition.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/CompiledProblemDefinition.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/CompiledProblemDefinition.cs	(revision 17225)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 
@@ -51,5 +52,4 @@
     where TEncoding : class, IEncoding<TEncodedSolution>
     where TEncodedSolution : class, IEncodedSolution {
-
     protected CompiledSingleObjectiveProblemDefinition() : base() { }
 
@@ -72,5 +72,4 @@
     where TEncoding : class, IEncoding<TEncodedSolution>
     where TEncodedSolution : class, IEncodedSolution {
-
     protected CompiledMultiObjectiveProblemDefinition() : base() { }
 
@@ -79,7 +78,8 @@
 
     #region ISingleObjectiveProblemDefinition<TEncoding,TEncodedSolution> Members
-
     public int Objectives => Maximization.Length;
     public abstract bool[] Maximization { get; }
+    public abstract IReadOnlyList<double[]> BestKnownFront { get; }
+    public abstract double[] ReferencePoint { get; }
     public abstract double[] Evaluate(TEncodedSolution individual, IRandom random);
     public abstract void Analyze(TEncodedSolution[] individuals, double[][] qualities, ResultCollection results, IRandom random);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProblemDefinitionScript.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProblemDefinitionScript.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProblemDefinitionScript.cs	(revision 17225)
@@ -20,7 +20,9 @@
 #endregion
 
+using System.Collections.Generic;
 using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 
@@ -47,9 +49,9 @@
     }
 
-    int IMultiObjectiveProblemDefinition<TEncoding, TEncodedSolution>.Objectives => CompiledProblemDefinition.Objectives;
+    public int Objectives => CompiledProblemDefinition.Objectives;
+    public IReadOnlyList<double[]> BestKnownFront => CompiledProblemDefinition.BestKnownFront;
+    public double[] ReferencePoint => CompiledProblemDefinition.ReferencePoint;
+    public bool[] Maximization => CompiledProblemDefinition.Maximization;
 
-    bool[] IMultiObjectiveProblemDefinition<TEncoding, TEncodedSolution>.Maximization {
-      get { return CompiledProblemDefinition.Maximization; }
-    }
 
     double[] IMultiObjectiveProblemDefinition<TEncoding, TEncodedSolution>.Evaluate(TEncodedSolution individual, IRandom random) {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProgrammableProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProgrammableProblem.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/MultiObjectiveProgrammableProblem.cs	(revision 17225)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using System.Drawing;
 using HEAL.Attic;
@@ -59,4 +60,5 @@
     }
 
+
     [StorableConstructor]
     protected MultiObjectiveProgrammableProblem(StorableConstructorFlag _) : base(_) { }
@@ -69,5 +71,5 @@
       : base(encoding) {
       Parameters.Add(new FixedValueParameter<MultiObjectiveProblemDefinitionScript<TEncoding, TEncodedSolution>>("ProblemScript", "Defines the problem.",
-        new MultiObjectiveProblemDefinitionScript<TEncoding, TEncodedSolution>() { Name = Name }));
+        new MultiObjectiveProblemDefinitionScript<TEncoding, TEncodedSolution>() {Name = Name}));
       ProblemScript.Encoding = (TEncoding)encoding.Clone();
 
@@ -93,5 +95,5 @@
     private void OnProblemDefinitionChanged() {
       Parameters.Remove("Maximization");
-      Parameters.Add(new ValueParameter<BoolArray>("Maximization", "Set to false if the problem should be minimized.", (BoolArray)new BoolArray(Maximization).AsReadOnly()) { Hidden = true });
+      Parameters.Add(new ValueParameter<BoolArray>("Maximization", "Set to false if the problem should be minimized.", (BoolArray)new BoolArray(Maximization).AsReadOnly()) {Hidden = true});
       Encoding = (TEncoding)ProblemScript.Encoding.Clone();
 
@@ -108,5 +110,13 @@
 
     public override bool[] Maximization {
-      get { return Parameters.ContainsKey("ProblemScript") ? ProblemDefinition.Maximization : new[] { false }; }
+      get { return Parameters.ContainsKey("ProblemScript") ? ProblemDefinition.Maximization : new[] {false}; }
+    }
+
+    public override IReadOnlyList<double[]> BestKnownFront {
+      get { return Parameters.ContainsKey("ProblemScript") ? ProblemDefinition.BestKnownFront : null; }
+    }
+
+    public override double[] ReferencePoint {
+      get { return Parameters.ContainsKey("ProblemScript") ? ProblemDefinition.ReferencePoint : null; }
     }
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/SingleObjectiveProblemDefinitionScript.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/SingleObjectiveProblemDefinitionScript.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/SingleObjectiveProblemDefinitionScript.cs	(revision 17225)
@@ -48,7 +48,5 @@
     }
 
-    bool ISingleObjectiveProblemDefinition<TEncoding, TEncodedSolution>.Maximization {
-      get { return CompiledProblemDefinition.Maximization; }
-    }
+    public bool Maximization => CompiledProblemDefinition.Maximization;
 
     double ISingleObjectiveProblemDefinition<TEncoding, TEncodedSolution>.Evaluate(TEncodedSolution individual, IRandom random) {
@@ -63,5 +61,5 @@
     }
 
-    bool ISingleObjectiveProblemDefinition<TEncoding, TEncodedSolution>.IsBetter(double quality, double bestQuality) {
+    public bool IsBetter(double quality, double bestQuality) {
       return CompiledProblemDefinition.IsBetter(quality, bestQuality);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/CrowdingAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/CrowdingAnalyzer.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/CrowdingAnalyzer.cs	(revision 17225)
@@ -30,10 +30,6 @@
 namespace HeuristicLab.Problems.TestFunctions.MultiObjective {
   [StorableType("F06FB45C-051E-4AD8-BD82-16DA9DCBCACB")]
-  [Item("CrowdingAnalyzer", "The mean crowding distance for each point of the Front (see Multi-Objective Performance Metrics - Shodhganga for more information)")]
+  [Item("CrowdingAnalyzer", "This analyzer is functionally equivalent to the CrowdingAnalyzer in HeuristicLab.Analysis, but is kept as not to break backwards compatibility")]
   public class CrowdingAnalyzer : MOTFAnalyzer {
-
-    public ILookupParameter<DoubleMatrix> BoundsParameter {
-      get { return (ILookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
-    }
 
     public IResultParameter<DoubleValue> CrowdingResultParameter {
@@ -43,7 +39,5 @@
     [StorableConstructor]
     protected CrowdingAnalyzer(StorableConstructorFlag _) : base(_) { }
-    public CrowdingAnalyzer(CrowdingAnalyzer original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    public CrowdingAnalyzer(CrowdingAnalyzer original, Cloner cloner): base(original, cloner) {}
     public override IDeepCloneable Clone(Cloner cloner) {
       return new CrowdingAnalyzer(this, cloner);
@@ -51,18 +45,12 @@
 
     public CrowdingAnalyzer() {
-      Parameters.Add(new LookupParameter<DoubleMatrix>("Bounds",
-        "The bounds of the solution given as either one line for all variables or a line for each variable. The first column specifies lower bound, the second upper bound."));
-      Parameters.Add(new ResultParameter<DoubleValue>("Crowding", "The average corwding value of all points (excluding infinities)"));
+      Parameters.Add(new ResultParameter<DoubleValue>("Crowding", "The average corwding distance of all points (excluding infinities)"));
       CrowdingResultParameter.DefaultValue = new DoubleValue(double.NaN);
-
     }
 
     public override IOperation Apply() {
       var qualities = QualitiesParameter.ActualValue;
-      var bounds = BoundsParameter.ActualValue;
-
-      var crowdingDistance = Crowding.Calculate(qualities.Select(x => x.ToArray()), bounds.CloneAsMatrix());
+      var crowdingDistance = CrowdingCalculator.CalculateCrowding(qualities);
       CrowdingResultParameter.ActualValue.Value = crowdingDistance;
-
       return base.Apply();
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/GenerationalDistanceAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/GenerationalDistanceAnalyzer.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/GenerationalDistanceAnalyzer.cs	(revision 17225)
@@ -30,5 +30,5 @@
 namespace HeuristicLab.Problems.TestFunctions.MultiObjective {
   [StorableType("EBC72F16-E329-4D18-800C-8642EFD0F05C")]
-  [Item("GenerationalDistanceAnalyzer", "The generational distance between the current and the best known front (see Multi-Objective Performance Metrics - Shodhganga for more information)")]
+  [Item("GenerationalDistanceAnalyzer", "This analyzer is functionally equivalent to the GenerationalDistanceAnalyzer in HeuristicLab.Analysis, but is kept as not to break backwards compatibility")]
   public class GenerationalDistanceAnalyzer : MOTFAnalyzer {
 
@@ -63,12 +63,9 @@
     public override IOperation Apply() {
       var qualities = QualitiesParameter.ActualValue;
-      int objectives = qualities[0].Length;
-
-      var optimalfront = TestFunctionParameter.ActualValue.OptimalParetoFront(objectives);
+      var optimalfront = TestFunctionParameter.ActualValue.OptimalParetoFront(qualities[0].Length);
       if (optimalfront == null) return base.Apply();
 
-      var distance = GenerationalDistance.Calculate(qualities.Select(x => x.CloneAsArray()), optimalfront, Dampening);
-      GenerationalDistanceResultParameter.ActualValue.Value = distance;
-
+      var q = qualities.Select(x => x.ToArray());
+      GenerationalDistanceResultParameter.ActualValue.Value = GenerationalDistance.Calculate(q, optimalfront, Dampening);
       return base.Apply();
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/HypervolumeAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/HypervolumeAnalyzer.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/HypervolumeAnalyzer.cs	(revision 17225)
@@ -32,5 +32,5 @@
 namespace HeuristicLab.Problems.TestFunctions.MultiObjective {
   [StorableType("13D363E4-76FF-4A5A-9B2C-767D9E880E4B")]
-  [Item("HypervolumeAnalyzer", "Computes the enclosed Hypervolume between the current front and a given reference Point")]
+  [Item("HypervolumeAnalyzer", "This analyzer is functionally equivalent to the HypervolumeAnalyzer in HeuristicLab.Analysis, but is kept as not to break backwards compatibility")]
   public class HypervolumeAnalyzer : MOTFAnalyzer {
 
@@ -38,10 +38,13 @@
       get { return (ILookupParameter<DoubleArray>)Parameters["ReferencePoint"]; }
     }
+
     public IResultParameter<DoubleValue> HypervolumeResultParameter {
       get { return (IResultParameter<DoubleValue>)Parameters["Hypervolume"]; }
     }
+
     public IResultParameter<DoubleValue> BestKnownHypervolumeResultParameter {
       get { return (IResultParameter<DoubleValue>)Parameters["Best known hypervolume"]; }
     }
+
     public IResultParameter<DoubleValue> HypervolumeDistanceResultParameter {
       get { return (IResultParameter<DoubleValue>)Parameters["Absolute Distance to BestKnownHypervolume"]; }
@@ -53,7 +56,6 @@
     }
 
-    protected HypervolumeAnalyzer(HypervolumeAnalyzer original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected HypervolumeAnalyzer(HypervolumeAnalyzer original, Cloner cloner) : base(original, cloner) {}
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new HypervolumeAnalyzer(this, cloner);
@@ -68,6 +70,4 @@
       BestKnownHypervolumeResultParameter.DefaultValue = new DoubleValue(0);
       HypervolumeDistanceResultParameter.DefaultValue = new DoubleValue(0);
-
-
     }
 
@@ -75,15 +75,13 @@
       var qualities = QualitiesParameter.ActualValue;
       var testFunction = TestFunctionParameter.ActualValue;
-      int objectives = qualities[0].Length;
+      var objectives = qualities[0].Length;
       var referencePoint = ReferencePointParameter.ActualValue;
 
-      double best = BestKnownHypervolumeResultParameter.ActualValue.Value;
+      var best = BestKnownHypervolumeResultParameter.ActualValue.Value;
       if (referencePoint.SequenceEqual(testFunction.ReferencePoint(objectives))) {
         best = Math.Max(best, testFunction.OptimalHypervolume(objectives));
       }
 
-      IEnumerable<double[]> front = NonDominatedSelect.SelectNonDominatedVectors(qualities.Select(q => q.ToArray()), testFunction.Maximization(objectives), true);
-
-      double hv = Hypervolume.Calculate(front, referencePoint.ToArray(), testFunction.Maximization(objectives));
+      var hv = HypervolumeCalculator.CalculateHypervolume(qualities.Select(x=>x.CloneAsArray()).ToArray(), referencePoint.ToArray(), testFunction.Maximization(objectives));
 
       if (hv > best) {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs	(revision 17225)
@@ -30,7 +30,9 @@
 namespace HeuristicLab.Problems.TestFunctions.MultiObjective {
   [StorableType("EC99F3C1-D8D2-4738-9523-0D07438647A5")]
-  [Item("InvertedGenerationalDistanceAnalyzer", "The inverted generational distance between the current and the best known front (see Multi-Objective Performance Metrics - Shodhganga for more information)")]
+  [Item("InvertedGenerationalDistanceAnalyzer", "This analyzer is functionally equivalent to the InvertedGenerationalDistanceAnalyzer in HeuristicLab.Analysis, but is kept as not to break backwards compatibility")]
   public class InvertedGenerationalDistanceAnalyzer : MOTFAnalyzer {
-    public override bool EnabledByDefault { get { return false; } }
+    public override bool EnabledByDefault {
+      get { return false; }
+    }
 
     private IFixedValueParameter<DoubleValue> DampeningParameter {
@@ -51,5 +53,4 @@
       Parameters.Add(new ResultParameter<DoubleValue>("Inverted Generational Distance", "The genrational distance between the current front and the optimal front"));
       InvertedGenerationalDistanceResultParameter.DefaultValue = new DoubleValue(double.NaN);
-
     }
 
@@ -64,17 +65,11 @@
     public override IOperation Apply() {
       var qualities = QualitiesParameter.ActualValue;
-      var testFunction = TestFunctionParameter.ActualValue;
-      int objectives = qualities[0].Length;
-
-      var optimalfront = testFunction.OptimalParetoFront(objectives);
+      var optimalfront = TestFunctionParameter.ActualValue.OptimalParetoFront(qualities[0].Length);
       if (optimalfront == null) return base.Apply();
 
-      var invertedGenerationalDistance = InvertedGenerationalDistance.Calculate(qualities.Select(q => q.ToArray()), optimalfront, DampeningParameter.Value.Value);
-      InvertedGenerationalDistanceResultParameter.ActualValue.Value = invertedGenerationalDistance;
-
+      var q = qualities.Select(x => x.ToArray());
+      InvertedGenerationalDistanceResultParameter.ActualValue.Value = InvertedGenerationalDistance.Calculate(q, optimalfront, Dampening);
       return base.Apply();
     }
-
-
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/MOTFAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/MOTFAnalyzer.cs	(revision 17224)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/MOTFAnalyzer.cs	(revision 17225)
@@ -33,5 +33,7 @@
   [StorableType("CFBB2CAB-C1B7-4F14-9A01-6D5624B7B681")]
   public abstract class MOTFAnalyzer : SingleSuccessorOperator, IMultiObjectiveTestFunctionAnalyzer {
-    public virtual bool EnabledByDefault { get { return true; } }
+    public virtual bool EnabledByDefault {
+      get { return true; }
+    }
 
     public IScopeTreeLookupParameter<DoubleArray> QualitiesParameter {
